// Arduino UNO, Pro mini
//пульт кнопочный с дисплеем 0.96 для RAY 2021
#include <iarduino_OLED_txt.h>                             // Подключаем библиотеку iarduino_OLED.
iarduino_OLED_txt myOLED(0x3C);                                // Объявляем объект myOLED, указывая адрес дисплея на шине I2C: 0x3C или 0x3D.
 extern uint8_t SmallFontRus[];                            // Подключаем шрифты  SmallFontRus и MediumFontRus
 extern uint8_t MediumFontRus[]; 
byte fl=0;//флаг состояний
byte S=0; byte K=0;//переменные хранения номера режима и номера нажатой кнопки
void setup(){                                              //
 myOLED.begin();                                           // Инициируем работу с дисплеем.
 myOLED.setFont(SmallFontRus);                             // Указываем шрифт который требуется использовать для вывода цифр и текста.
 smena_ekr();
 ///////
 Serial.begin(57600);
  for(int i=2;i<=8;i++){
  pinMode(i, INPUT);//кнопку подключить
  digitalWrite(i, HIGH);// включить подтягивающий резистор к ней
  }
  ////
 }                       
 void loop(){
if(fl!=2&&digitalRead (2)==LOW){K=1;smena_ekr();if(S==1){Serial.print("11");Serial.print('\n');}if(S==2){Serial.print("1");Serial.print('\n');}if(S==3){Serial.print("111");Serial.print('\n');}fl=2;delay(200);}//если нажата кнопка 2
if(fl!=3&&digitalRead (3)==LOW){K=2;smena_ekr();if(S==1){Serial.print("33");Serial.print('\n');}if(S==2){Serial.print("3");Serial.print('\n');}if(S==3){Serial.print("333");Serial.print('\n');}fl=3;delay(200);}//если нажата кнопка 3
if(fl!=4&&digitalRead (4)==LOW){K=3;smena_ekr();if(S==1){Serial.print("44");Serial.print('\n');}if(S==2){Serial.print("4");Serial.print('\n');}if(S==3){Serial.print("444");Serial.print('\n');}fl=4;delay(200);}//если нажата кнопка 4
if(fl!=5&&digitalRead (5)==LOW){K=4;smena_ekr();if(S==1){Serial.print("22");Serial.print('\n');}if(S==2){Serial.print("2");Serial.print('\n');}if(S==3){Serial.print("222");Serial.print('\n');}fl=5;delay(200);}//если нажата кнопка 5
if(fl!=6&&digitalRead (6)==LOW){K=5;smena_ekr();if(S==1){Serial.print("55");Serial.print('\n');}if(S==2){Serial.print("5");Serial.print('\n');}if(S==3){Serial.print("555");Serial.print('\n');}fl=6;delay(200);}//если нажата кнопка 6
if(fl!=7&&digitalRead (7)==LOW){K=6;smena_ekr();if(S==1){Serial.print("66");Serial.print('\n');}if(S==2){Serial.print("6");Serial.print('\n');}if(S==3){Serial.print("666");Serial.print('\n');}fl=7;delay(200);}//если нажата кнопка 7
if(fl!=8&&digitalRead (8)==LOW){S++;if(S>3){S=0;}fl=8;delay(200);}//если нажата кнопка 8 меняем режимы управления
///////
if(fl!=0&&digitalRead (2)==HIGH&&digitalRead (3)==HIGH&&digitalRead (4)==HIGH&&digitalRead (5)==HIGH&&digitalRead
(6)==HIGH&&digitalRead (7)==HIGH){K=0;smena_ekr();Serial.print("A");Serial.print('\n');fl=0;delay(200);}//если отпущены все кнопки
///////
 }
/////////////
void smena_ekr ()// функция отрисовывает меню пульта 
{
 //////////
 if(S==0){
 myOLED.clrScr(); 
 myOLED.setFont( MediumFontRus);
 myOLED.setCursor(20,3); myOLED.print("RAY 2021");
 myOLED.setCursor(30,6); myOLED.print("пульт");  
 myOLED.setFont(SmallFontRus);  
 }
 ////////// 
 if(S==1){
myOLED.clrScr();
myOLED.invText(1); myOLED.setCursor(0,0); myOLED.print("Статичные положения");                             
if(K!=1){myOLED.invText(0);}else{myOLED.invText(1);} myOLED.setCursor(0,2); myOLED.print("Поза ,Звёздочка,"); 
if(K!=2){myOLED.invText(0);}else{myOLED.invText(1);} myOLED.setCursor(0,3); myOLED.print("Поза ,Служу,");
if(K!=3){myOLED.invText(0);}else{myOLED.invText(1);}myOLED.setCursor(0,4); myOLED.print("Поза ,Грусть,"); 
if(K!=4){myOLED.invText(0);}else{myOLED.invText(1);} myOLED.setCursor(0,5); myOLED.print("Поза ,Смирно,");
if(K!=5){myOLED.invText(0);}else{myOLED.invText(1);} myOLED.setCursor(0,6); myOLED.print("Поза ,Выпад,"); 
if(K!=6){myOLED.invText(0);}else{myOLED.invText(1);} myOLED.setCursor(0,7); myOLED.print("Поза ,На цыпочках,");
 }
/////// 
if(S==2){
myOLED.clrScr();
myOLED.invText(1); myOLED.setCursor(0,0); myOLED.print("Простые движения");                             
if(K!=1){myOLED.invText(0);}else{myOLED.invText(1);} myOLED.setCursor(0,2); myOLED.print("Поворот головы"); 
if(K!=2){myOLED.invText(0);}else{myOLED.invText(1);} myOLED.setCursor(0,3); myOLED.print("Шаг левой");
if(K!=3){myOLED.invText(0);}else{myOLED.invText(1);} myOLED.setCursor(0,4); myOLED.print("Шаг правой"); 
if(K!=4){myOLED.invText(0);}else{myOLED.invText(1);} myOLED.setCursor(0,5); myOLED.print("Шевеление кистями");
if(K!=5){myOLED.invText(0);}else{myOLED.invText(1);} myOLED.setCursor(0,6); myOLED.print("Поднять пр. руку"); 
if(K!=6){myOLED.invText(0);}else{myOLED.invText(1);} myOLED.setCursor(0,7); myOLED.print("Поднять лев. руку");
 }
///////
if(S==3){
myOLED.clrScr();
myOLED.invText(1); myOLED.setCursor(0,0); myOLED.print("Ситуативные действия");                             
if(K!=1){myOLED.invText(0);}else{myOLED.invText(1);} myOLED.setCursor(0,2); myOLED.print("Действие ,Танцы,"); 
if(K!=2){myOLED.invText(0);}else{myOLED.invText(1);} myOLED.setCursor(0,3); myOLED.print("Действие ,Флаг,");
if(K!=3){myOLED.invText(0);}else{myOLED.invText(1);} myOLED.setCursor(0,4); myOLED.print("Действие ,Лыжи,"); 
if(K!=4){myOLED.invText(0);}else{myOLED.invText(1);} myOLED.setCursor(0,5); myOLED.print("Действие ,Игра,");
if(K!=5){myOLED.invText(0);}else{myOLED.invText(1);} myOLED.setCursor(0,6); myOLED.print("Действие ,Меч,"); 
if(K!=6){myOLED.invText(0);}else{myOLED.invText(1);} myOLED.setCursor(0,7); myOLED.print("Действие ,Сила,");
 } 
  }
 ////////////////
